#ifndef BITBOARD_H_INCLUDED
#define BITBOARD_H_INCLUDED

#include "shogi.h"

#define BB_BOCCUPY (ptree->posi.b_occupied) // ׂĂ̋
#define BB_BPAWN (ptree->posi.b_pawn)		// 
#define BB_BTGOLD (ptree->posi.b_tgold)		// Ɛ
#define BB_B_HDK (ptree->posi.b_hdk)		// nEE
#define BB_B_BH (ptree->posi.b_bh)			// pEn
#define BB_B_RD (ptree->posi.b_rd)			// E
#define BB_BPAWN (ptree->posi.b_pawn)		// 
#define BB_BLANCE (ptree->posi.b_lance)		// 
#define BB_BKNIGHT (ptree->posi.b_knight)	// j
#define BB_BSILVER (ptree->posi.b_silver)	// 
#define BB_BGOLD (ptree->posi.b_gold)		// 
#define BB_BBISHOP (ptree->posi.b_bishop)	// p
#define BB_BROOK (ptree->posi.b_rook)		// 
#define BB_BKING (abb_mask[SQ_BKING])		// 

// ȉ͐
#define BB_BPRO_PAWN (ptree->posi.b_pro_pawn)
#define BB_BPRO_LANCE (ptree->posi.b_pro_lance)
#define BB_BPRO_KNIGHT (ptree->posi.b_pro_knight)
#define BB_BPRO_SILVER (ptree->posi.b_pro_silver)
#define BB_BHORSE (ptree->posi.b_horse)
#define BB_BDRAGON (ptree->posi.b_dragon)

// ȉe͐Ɠ
#define BB_WOCCUPY (ptree->posi.w_occupied)
#define BB_WPAWN  (ptree->posi.w_pawn)
#define BB_WTGOLD (ptree->posi.w_tgold)
#define BB_W_HDK (ptree->posi.w_hdk)
#define BB_W_BH (ptree->posi.w_bh)
#define BB_W_RD (ptree->posi.w_rd)
#define BB_WPAWN (ptree->posi.w_pawn)
#define BB_WLANCE (ptree->posi.w_lance)
#define BB_WKNIGHT (ptree->posi.w_knight)
#define BB_WSILVER (ptree->posi.w_silver)
#define BB_WGOLD (ptree->posi.w_gold)
#define BB_WBISHOP (ptree->posi.w_bishop)
#define BB_WROOK (ptree->posi.w_rook)
#define BB_WKING (abb_mask[SQ_WKING])
#define BB_WPRO_PAWN (ptree->posi.w_pro_pawn)
#define BB_WPRO_LANCE (ptree->posi.w_pro_lance)
#define BB_WPRO_KNIGHT (ptree->posi.w_pro_knight)
#define BB_WPRO_SILVER (ptree->posi.w_pro_silver)
#define BB_WHORSE (ptree->posi.w_horse)
#define BB_WDRAGON (ptree->posi.w_dragon)

#define BB_OCCUPY(bo, bb, bw) BBor(bo, bb, bw);

extern bitboard_t abb_mask[nsquare]; // nsquarëʒu1bb@rbgʒurI_ap
extern bitboard_t file_attacks[nsquare][128]; // ړ
extern bitboard_t rank_attacks[nsquare][128]; // iړ

extern bitboard_t b_knight_attacks[nsquare];
extern bitboard_t w_knight_attacks[nsquare];
extern bitboard_t b_silver_attacks[nsquare];
extern bitboard_t w_silver_attacks[nsquare];
extern bitboard_t b_gold_attacks[nsquare];
extern bitboard_t w_gold_attacks[nsquare];
extern bitboard_t king_attacks[nsquare];
extern bitboard_t bishop_attacks[nsquare][16384];
extern bitboard_t rook_attacks[nsquare][16384];
extern bitboard_t new_rook_attacks[nsquare][16384];

#endif // ifndef BITBOARD_H_INCLUDED