#include "shogi.h"

#include <windows.h>
#include <cstdlib>
#include <random>

std::random_device rnd;
std::mt19937_64 mt(rnd());


uint64 random_uint64() { // 64bit 
	return (uint64)(mt());
}

uint64 random_uint64_fewbits() { // Ăbit炵
	return random_uint64() & random_uint64() & random_uint64();
}

// 2^128̎
unsigned long getRandXorShift128() {

	static unsigned long x = 123456789;
	static unsigned long y = 362436069;
	static unsigned long z = 521288629;
	static unsigned long w = 88675123;
	static unsigned long t = 0;
	t = (x ^ (x << 11));
	x = y;
	y = z;
	z = w;

	return (w = (w ^ (w >> 19)) ^ (t ^ (t >> 8)));
}