#ifndef BIT_H_INCLUDED
#define BIT_H_INCLUDED

typedef unsigned long long uint64;
typedef struct { uint64 p[3]; } bitboard_t;

#define BBIni(b) (b).p[0] = (b).p[1] = (b).p[2] = 0

/*  bitboard \R̃rbgƂ̘_a
*  bitboard Ŝ 0 ǂ
*  BBTest ͍폜
*/
#define BBToU(b)  ((b).p[0] | (b).p[1] | (b).p[2])

#define BBand(b,b1,b2)  (b).p[0] = (b1).p[0] & (b2).p[0], (b).p[1] = (b1).p[1] & (b2).p[1], (b).p[2] = (b1).p[2] & (b2).p[2]
#define BBor(b,b1,b2)   (b).p[0] = (b1).p[0] | (b2).p[0], (b).p[1] = (b1).p[1] | (b2).p[1], (b).p[2] = (b1).p[2] | (b2).p[2]
#define BBXor(b,b1,b2)  (b).p[0] = (b1).p[0] ^ (b2).p[0], (b).p[1] = (b1).p[1] ^ (b2).p[1], (b).p[2] = (b1).p[2] ^ (b2).p[2]
#define BBNot(b,b1)  (b).p[0] = (b1).p[0] ^ 0x1FF, (b).p[1] = (b1).p[1] ^ 0x7FFFFFFFFFFFFFFF, (b).p[2] = (b1).p[2] ^ 0x1FF
#define BBNotAnd(b,b1,b2)  (b).p[0] = (b1).p[0] & ~(b2).p[0], (b).p[1] = (b1).p[1] & ~(b2).p[1], (b).p[2] = (b1).p[2] & ~(b2).p[2]
#define BBandor(b,b1,b2) (b).p[0] |= (b1).p[0] & (b2).p[0], (b).p[1] |= (b1).p[1] & (b2).p[1], (b).p[2] |= (b1).p[2] & (b2).p[2]
#define BBshift_w(b,b1) (b).p[0] = (b1).p[0] << 1, (b).p[1] = (b1).p[1] << 1, (b).p[2] = (b1).p[2] << 1
#define BBshift_b(b,b1) (b).p[0] = (b1).p[0] >> 1, (b).p[1] = (b1).p[1] >> 1, (b).p[2] = (b1).p[2] >> 1
#define BBcontract(b1,b2) ( ( (b1).p[0] & (b2).p[0] ) | ( (b1).p[1] & (b2).p[1] ) | ( (b1).p[2] & (b2).p[2] ) )


#define FirstOne(bb) first_one012( bb.p[2], bb.p[1], bb.p[0] ) //擪rbg珉߂ɃrbgĂʒu𔭌
#define LastOne(bb) last_one012( bb.p[2], bb.p[1], bb.p[0] ) //ʃrbg(ry
#define bTopThree(bb) BbitTopThree(bb.p[0], bb.p[1], bb.p[2])
#define bUnderSix(bb) BbitUnderSix(bb.p[0], bb.p[1], bb.p[2])
#define wTopThree(bb) WbitTopThree(bb.p[0], bb.p[1], bb.p[2])
#define wUnderSix(bb) WbitUnderSix(bb.p[0], bb.p[1], bb.p[2])




#define Xor(sq, b) ((b).p[0] ^= abb_mask[sq].p[0], (b).p[1] ^= abb_mask[sq].p[1], (b).p[2] ^= abb_mask[sq].p[2]) //rbgƂ̔rI_a

/*  rbg̐JEg
*
*/
#define BitCount(bit) bitcount(bit.p[0],bit.p[1],bit.p[2])

#define SetClear(b)     (b).p[0] ^= (bb_set_clear.p[0]),  \
	                    (b).p[1] ^= (bb_set_clear.p[1]),  \
						(b).p[2] ^= (bb_set_clear.p[2])

#endif // ifndef BIT_H_INCLUDED