#ifndef USI_H_INCLUDED
#define USI_H_INCLUDED

#include <cstdio>
#include "shogi.h"

typedef unsigned char KomaInf;

KomaInf SFENKomaNameToValue(char komaName);
KomaInf MochigomaSFENKomaNameToValue(char komaName, int turn);
KomaInf SFENKomaNameToValue(char komaName);
int AddMove(const char *buf, tree_t *ptree);
void AddAllMoves(const char *buf, int len, tree_t *ptree);
void ParseAllTimes(const char *buf, int turn);
void USI_move(unsigned int move);
void Info(tree_t *ptree, unsigned int *pv, int bestValue);
void MakeCustom(char *buf, tree_t *ptree);

#endif // ifndef USI_H_INCLUDED